=== customs/bare/Makefile ===
# Stub Makefile for custom modules in the bare version of Sherlock
DIRS+=customs/bare/lib
CUSTOM_LIB_MODULES+=$(o)/customs/bare/lib/custom
