=== debian/changelog ===
holmes (4.0) stable; urgency=low

  A huge release moving most of the features from the commercial version to
  the free version.  The following new major features are now supported:

      * Site compression (the search server may only show the best 2 pages
	from one domain).
      * Automatic page ranking (based on the links between the pages). 

      * New intelligent gatherer (it chooses which pages to gather according
	to their ranks, it is much faster and more scalable, and it can
	refresh pages more often than the old gatherer from before v4.0).
      * Splitting the index into independent areas (one search engine for a
	number of domains). 

      * Extended image search: detection of near-duplicate images and
	searching for similar images.
      * Gathering audio files (in the MP3 and OGG format) and indexing their
	ID3 tags.

  Notable minor features include:

      * Added parsers for ZIP files (processes the largest file from the
	archive), and for XHTML and WML files.
      * The indexer now supports multiple sources.
      * The indexer resolver has been parallelized.
      * Support for spelling typos caused by a wrong keybord layout.
      * Language recognizer has acquired a tunable threshold, below which
        the recognizer admits that it failed to recognize the language.
	The default language tables now also include Russian.

  Besides these changes, the codebase has been cleaned up and better separated
  to a general UCW library and the actual search engine.  We have cleaned up
  the interfaces of the UCW library to make it easier to use them in other
  projects. Some of the changes were not backward compatible, but it should be
  very easy to fix the callers.  Notable new library features include:

      * The generic sorter module has been completely rewritten, the new
	version is much faster and more general. It now lives in
	lib/sorter/sorter.h, the old interface lib/sorter.h is gone. The array
	sorter (lib/arraysort.h) now has a more powerful sibling in
	lib/sorter/array.h, which is well suited for sorting of large arrays.
      * A lot of new documentation has been written for the UCW library.
      * New logging system capable of logging to multiple streams.
      * The build system now supports both building locally in the `run'
        directory and building for installation to a stable location.
      * We now use pkg-config to build libraries (and the .pc files are
	installed as a part of the library API), so the ever recurring
	problems with ordering of linker parameters should be gone.
      * A new fastbuf backend fb-direct has been added for direct I/O on
	files.  Another fastbuf backend fb-pool can take care of writing to a
	string allocated in a mempool.  The fb-file fastbuf backend is now
	able to optimize buffering for backward reading and intensive seeking.
      * Added a module for asynchronous direct I/O on files (lib/asio.h).

 -- Martin Mares <mj@ucw.cz>  Thu, 26 Jul 2007 11:27:31 +0200

holmes (3.11) stable; urgency=low

  Incompatible:

      * Changed format of Watson configuration files and location of downloaded
        and parsed logs.
      * Attributes are not longer limited to MAX_ATTR_SIZE.

  Libraries:

      * The libucw and libsh no longer define the following types: sbyte, word,
        sword and addr_int_t. Please use s8, u16, s16 and uintptr_t instead.
      * Fastbufs now work better on unseekable files. The seek callback returns
        success, bseek() and bsetpos() dies if seek fails, bfilesize() returns
        -1 if the file is unseekable.
      * lib/fastbuf.h no longer includes <stdio.h>. If you need SEEK_xxx, please
        include <stdio.h> or <unistd.h> yourself. If you need EOF, please use
        a test for a negative number instead as stdio EOF doesn't have anything
        in common with the fixed value of -1 used by the fastbufs.
      * Fastbuf functions for reading and writing of multi-byte numbers have been
        moved to lib/ff-binary.h. Specific number endianity can be requested.
      * Unaligned access macros have been replaced by functions (old names kept
        for compatibility) and they also have variants with specific endianity.
        GET_U32_BE16 and GET_U32_16 have been removed as they are no longer used.
      * Memory pools now support growing of the last allocated item and
        saving/restoring states.
      * Libgath has been split to libgath (without complex dependencies),
        libparse (various content parsers) and libproto (dowloader).

 -- Robert Spalek <robert@ucw.cz>  Thu, 26 Apr 2007 20:20:35 -0800

holmes (3.10.1) stable; urgency=low

  * Support for custom spelling sequences (for example double-letter
    equivalents in Polish language).
  * Added the "raw" analyzer for filtering of HTML documents with specific
    substrings in their unparsed content.
  * Better threading support in libucw and libsh.
  * Improved bucket interface in libsh.

 -- Martin Mares <mj@ucw.cz>  Mon, 18 Dec 2006 14:26:35 +0100

holmes (3.10) stable; urgency=low

  * Many optimizations in the indexer: resolver, ref-texts and everything related
    to link graphs is now significantly faster. The scanner is now able to run in
    multiple threads, achieving speedup almost 2 on a 2-way SMP system.
  * In addition to subindices (handled by different search servers), every (sub)index
    can be now split to several slices, handled by different threads of a single
    search server in parallel.
  * Added a general library for processing of images, capable of reading JPEG,
    PNG and GIF, writing JPEG and PNG (and optionally everything supported
    by GraphicsMagick) and performing basic operations like scaling really
    quickly. Added an image gatherer based on this library.
  * Basic libraries (libucw, liblang, libfilter and libanalyser) are now thread-safe.
    See lib/THREADS for details.

  Minor:

  * Documented adding of new charsets and languages: doc/charsets and doc/lang-tables.

